From iris.program_logic Require Export hoare weakestpre.
From iris.base_logic Require Export viewshifts.

Import uPred.

Section atomic.
  Context `{irisG Λ Σ}.

  Definition atomic_shift {A B : Type}
             (α: A → iProp Σ) (* atomic pre-condition *)
             (β: A → B → iProp Σ) (* atomic post-condition *)
             (Ei Eo: coPset) (* inside/outside masks *)
             (P : iProp Σ)
             (Q : A → B → iProp Σ) : iProp Σ :=
    (P ={Eo, Ei}=> ∃ x:A, α x ∗
     ((α x ={Ei, Eo}=∗ P) ∧
      (∀ y, β x y ={Ei, Eo}=∗ Q x y)))%I.

  Definition atomic_wp {A : Type}
             (α: A → iProp Σ) (* atomic pre-condition *)
             (β: A → val _ → iProp Σ) (* atomic post-condition *)
             (Ei Eo: coPset) (* inside/outside masks *)
             (e: expr _) : iProp Σ :=
    (∀ P Q, atomic_shift α β Ei Eo P Q -∗
      P -∗ WP e @ ⊤ {{ v, ∃ x: A, Q x v }})%I.
    
End atomic.
